// 下载弹窗事件
var uploadWin;//弹窗句柄
var bookId=1;//书本ID
var groupId=0;//分类ID
function startStudy(groupState){ 
    groupId=groupState;
	bookId= getCurBookId(); 
	getDownloadState(bookId,function(state,barVal){                               
		if(state==1){ //正在下载
			alertUploadWin(bookId);					
			uploadStart(bookId);
		}
		else if(state==2){//未下载，直接调用下载功能
			alertUploadWin(bookId);
		}
		else if(state==3){//暂停，直接调用下载功能	               
			alertUploadWin(bookId);
			updateProbar(barVal);
		}
		else if(state==4){//已下载完成  
		    window.location.href="list.html?bookId="+bookId+"&typeId="+groupId
		}
	});//获取下载状态值
}

//获取当前选中的书本ID
function getCurBookId(){
	var idStr=0;			
	$(".swiper-slide").each(function(index) {
		var curObj=$(this);				
		if(curObj.hasClass("swiper-slide-visible")){					
			var id=curObj.attr("id");					
			idStr=id.split('_')[1];	
		}			
	});	
	return idStr;
}

//获取下载状态
function getDownloadState(bookId,callback){
   var data = {"bookID":bookId};
   window.WebViewJavascriptBridge.callHandler(
		'downloadState'
		, data
		, function(responseData) {
            callback(responseData.state,responseData.progress);	//返回状态值
		}
   ); 
}

//弹出下载窗
function alertUploadWin(bookId){		
	var titText=getBookTitleById(bookId);
	var str="";
	str+='<div class="topbg"></div>';
	str+='<div class="uploadBox">';
	str+='<h3>'+titText+'</h3>';
	str+='<span id="proText">已下载<b id="percent">0</b>%</span>';
	str+='<div id="proBar"><span id="bar"></span></div>';
	str+='<div id="uploadTools"><a href="javascript:void(0)" id="btnStart" onclick="uploadStart('+bookId+')">开始</a><a href="javascript:void(0)" id="btnPause" onclick="uploadPause('+bookId+')">暂停</a><a href="javascript:void(0)" id="btnCancle" onclick="winClose()">隐藏</a></div>';
	str+='</div>';	
	uploadWin = dialog({		
		width:235,	
		height:139,	
		skin: 'msgTips',
		content: str
	});
	uploadWin.showModal();	
}

//根据ID获取书本名称
function getBookTitleById(bookId){
	var curTitle="";
	var dbBook=eval(bookJson);		
	$(dbBook).each(function(index){
		var curId=dbBook[index].bookId;
		if(curId==bookId){
			curTitle=dbBook[index].bookName;
		}
	});
	return curTitle;
}

//开始下载
function uploadStart(bookId){	
	//传入的进度值，小于100的整数
	$("#btnStart").hide();
	$("#btnPause").show();	
	//var pre=getPercentVal(bookId);//从后台获取下载进度值，值为小于等于100的整数值
	
	var data = {"bookID":bookId};
    window.WebViewJavascriptBridge.callHandler(
		'downloadStart'
		, data
		, function(responseData) {
			if(!responseData.scuss){
				autoCloseMsg(responseData.errorMsg,2000);
				uploadWin.remove().close();
			}
		}
    ); 	
	//var pre=100;
	//updateProbar(pre);
}

//暂停下载
function uploadPause(bookId){
	$("#btnStart").show();
	$("#btnPause").hide();
	var data = {"bookID":bookId};	
    window.WebViewJavascriptBridge.callHandler(
		'downloadPause'
		, data
		, function(responseData) {
			//return responseData.state;	//返回状态值 		
		}
    ); 	
}

//更新进度条的值，传入小于等于100的整型，如50代表50%；
function updateProbar(barVal){
	var allW=235;//进度条总长
	//进度百分比
	var percent=barVal/100; 
	var w=allW*percent;//当前步进的宽度值	
	$("#percent").html(barVal);	
    $("#bar").width(w);
	if(barVal==100){
		unzipHandle();//调用解压文件的方法
	}
}
//解压缩文件事件
function unzipHandle(){	
	window.WebViewJavascriptBridge.callHandler(
		'unzipHandle'
		, ''
		, function(responseData) {
			if(responseData.state){//解压完成
				if(uploadWin!=undefined){
					uploadWin.remove().close();
				}				
				window.location.href="list.html?bookId="+bookId+"&typeId="+groupId;		
			}
		}
	);
}


//关闭窗体
function winClose(){
	uploadWin.remove().close();
    window.WebViewJavascriptBridge.callHandler(
   'downloadExit'
   , ''
   , function(responseData) {
   
   }
   );
}


function checkPlatform(){
    //console.log("checkPlatform");
    var system =
    {
        win : false,
        mac : false,
        xll : false
    };
    //检测平台
    var p = navigator.platform;
    
    system.win = p.indexOf("Win") == 0;
    system.mac = p.indexOf("Mac") == 0;
    system.x11 = (p == "X11") || (p.indexOf("Linux") == 0);
    //跳转语句
    if(system.win||system.mac||system.xll)
    {
        console.log("PC端");
        return 0;
    }
    else
    {
        if(navigator.userAgent.indexOf("Mac")<0)
        {
            console.log("安卓端");
            return 1;
        }
        else
        {
            console.log("苹果端");
            return 2;
        }
        
    }
}


var loginWin;
//登录确认弹窗
function isLogined(){	
	var titText="你还没有登录，是否要登录？";
	var str="";
	str+='<div class="topbg"></div>';
	str+='<div class="msgTipsTit">';
	str+='<p>'+titText+'</p>';			
	str+='<div id="uploadTools"><a href="login.html" id="btnStart">好哒</a><a href="javascript:void(0)" id="btnCancle" onclick="loginClose()">算了</a></div>';
	str+='</div>';	
	loginWin = dialog({		
		width:235,	
		height:100,	
		skin: 'msgTips',
		content: str
	});
	loginWin.showModal();
}

//关闭窗体
function loginClose(){
	loginWin.close();	
}

function setupWebViewJavascriptBridge(callback) {
    if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge); }    
    if(checkPlatform() == 1){
        document.addEventListener('WebViewJavascriptBridgeReady', function() {
		  callback(WebViewJavascriptBridge)
		  }, false)
        return;
    }    
    if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback); }
    window.WVJBCallbacks = [callback];
    var WVJBIframe = document.createElement('iframe');
    WVJBIframe.style.display = 'none';
    WVJBIframe.src = 'wvjbscheme://__BRIDGE_LOADED__';
    document.documentElement.appendChild(WVJBIframe);
    setTimeout(function() { document.documentElement.removeChild(WVJBIframe) }, 0)
}

setupWebViewJavascriptBridge(function(bridge) {		
	bridge.registerHandler('updateProbar', function(data, responseCallback) {
		var progress = data.progress;
		var state = data.state;
		var errorMsg = data.errorMsg;
		
		if(state==1){//正在下载														
			updateProbar(progress)          
		}
		else if(state==2){//下载完成
			window.location.href="list.html?bookId="+bookId+"&typeId="+groupId;	
		}
		else if(state==3){//下载失败
			$("#btnStart").show();
			$("#btnPause").hide();
			alert("下载失败:" + errorMsg);	
		}
		//responseCallback(responseData)
	})
})

//定时关闭的对话杠，参数为内容和定时时间
function autoCloseMsg(title,time){
	var d = dialog({
		padding:10,
		skin:'timeWin',					
		content: title
	});
	d.showModal();
	setTimeout(function () {
		d.close().remove();
	}, time);	
}