// JavaScript Document
var typeId=0;//页面分类ID,0为全部，1为练习，2为故事，3为歌曲，默认为0，即为全部内容
var bookId=1;//书本ID,1为低版本，即3-4年级，2为高版本，即5-6年级，默认为1
//列表页是带两个参数进来的，如：list.html?bookId="+bookId+"&typeId="+groupId
var bookTitle="";
//初始化事件
function initEvent(){	
	bookId=request('bookId');//获取页面的书本ID
	typeId=request('typeId');//获取页面URL参数，类别ID
	bookTitle=getBookTitle(bookId);	
	$(".fix_h_M").html(bookTitle);
	var bookIdStr=parseInt(bookId)-1;
	$(".fix_h_L").html('<a href="index.html?bookId='+bookIdStr+'"></a>');//返回首页带上书本ID参数
	$("dt>a").bind("click",function(){
		var dtParent=$(this).parent();
		var dlParent=$(dtParent).parent();
		if($(dtParent).hasClass("cur")){			
			$(dtParent).removeClass("cur");
		}
		else{			
			$(dtParent).addClass("cur");
		}
		$(dlParent).children("dd").each(function(){
			if($(dtParent).hasClass("cur")){
				$(this).show();	
			}
			else{
				$(this).hide();	
			}
		});
	});		
}
//根据ID获取书本名称
function getBookTitle(bookId){
	var curTitle="";
	var dbBook=eval(bookJson);		
	$(dbBook).each(function(index){
		var curId=dbBook[index].bookId;
		if(curId==bookId){
			curTitle=dbBook[index].bookName;
		}
	});
	return curTitle;
}

//通过json读取单元列表
function readUnitListByJson(){	
	var obj;
	//根据书本ID调用不同的数据源
	if(bookId==1){
		obj =eval(dataJson1);
	}
	else if(bookId==2){
		obj =eval(dataJson2);
	}	
	$(obj).each(function(index){
		var temphtml ="";
		var htmlStr="";
		if(!(obj[index].partName=="" || obj[index].partName==null)){
			htmlStr += '<dl id="dl_'+obj[index].partId+'" class="close">';
			htmlStr += '	<dt><a href="javascript:void(0)">'+obj[index].partName+'</a></dt>'
			htmlStr += '</dl>'
		}
		$(".dlbox").append(htmlStr);
		//判断单元下是否有资源
		if(!(obj[index].unitChild=="" || obj[index].unitChild==null)){
			var unitListArray=obj[index].unitChild;				
			for(var i=0;i<unitListArray.length;i++){
				var unitName=unitListArray[i].uintName;	
				var unitId=unitListArray[i].unitId;	
				var unitIndex=unitListArray[i].unitIndex;
				var hrefUrl="";					
				
				//获取当前单元下的第一条记录
				if(typeId==0){
					//如果类型为0时，只需取第一记录即可
					var sourceId=unitListArray[i].modeChild[0].stemChild[0].sourceChild[0].sourceId;
					var url=unitListArray[i].modeChild[0].stemChild[0].sourceChild[0].sourceUrl;//只获取第一条记录
					hrefUrl=url+'?unitId='+unitId+'&sourceId='+sourceId+'&bookId='+bookId+'&typeId='+typeId;
				}
				else{
					//否则需要根据类型查询第一条记录
					var modelArray=unitListArray[i].modeChild;
					innerloop://嵌套循环						
					for(var m=0;m<modelArray.length;m++){
						var stemArray=modelArray[m].stemChild;						
						for(var n=0;n<stemArray.length;n++){
							var sourceArray=stemArray[n].sourceChild;						
							for(var p=0;p<sourceArray.length;p++){
								var curTypeId=sourceArray[p].typeId;
								if(typeId==curTypeId){
									var sourceId=sourceArray[p].sourceId;
									var url=sourceArray[p].sourceUrl;
									hrefUrl=url+'?unitId='+unitId+'&sourceId='+sourceId+'&bookId='+bookId+'&typeId='+typeId;
									break innerloop;//找到一个就直接退出嵌套循环了。
								}
							}
						}
					}					
				}
				//如果hrefUrl为空，表示在当前单元中没有查找到内容，就不显示这个单元的名称了。
				if(hrefUrl!=""){				
					temphtml += '<dd>';					
					temphtml += '	<a href="javascript:void(0)" hidHref="'+hrefUrl+'" id="'+unitId+'" hidUnitIndex="'+unitIndex+'">'+unitName+'</a>';
					temphtml += '</dd>';	
				}
			}					
		}	
		$("#dl_"+obj[index].partId).append(temphtml);
		
		//如果子节点不存在，父节点也无必要存在了。
		if(temphtml==""){
			$("#dl_"+obj[index].partId).remove();
		}
	});
	
	/*一级菜单点击事件--展开和收缩*/
	$(".dlbox dt a").bind("click",function(){
		var parentDl=$(this).parent().parent();
		var nextDD=$(this).parent().next();
		var dlID=$(parentDl).attr("id");
		if($(parentDl).hasClass("open")){
			$(parentDl).removeClass("open").addClass("close");
		}
		else{
			$(parentDl).removeClass("close").addClass("open");
		}
	})
	
	//绑定链接事件
	$(".dlbox dd a").bind("click",function(){
		var obj=$(this).get(0);
		var uID=$(obj).attr("id");		
		var gradeID=uID.split('_')[0];	
		//unlocked($(this).get(0));		
		//第一条不用解锁可以直接使用
		privilege(obj,gradeID);			
	})	
}
//保存已展开的列表ID
function saveOpenList(){
	var data = {"name":"cookieList","value":{"state":1,"backUrl": backUrl}};   
    window.WebViewJavascriptBridge.callHandler(
		'saveStudyData'
		, data
		, function() {			
		}
    );
}

//保存要跳转回来的URL地址，将地址存入后台
function saveBackUrl(backUrl){
	var data = {"name":"backUrl","value":{"state":1,"linkURL": backUrl}};   
    window.WebViewJavascriptBridge.callHandler(
		'saveStudyData'
		, data
		, function() {}
    );
}

//权限判断
function privilege(obj,gradeID){  
   var hrefUrl=$(obj).attr("hidHref"); 
   var hidUnitIndex=$(obj).attr("hidUnitIndex");   
   var data = {"gradeID":gradeID,"unitNum": hidUnitIndex};   
   window.WebViewJavascriptBridge.callHandler(
		'getControl'
		, data
		, function(responseData) {
			var state=responseData.state;
			//0 可用，1未登录 2 没有使用权限 (没有会员)
			if(state==0){                                                   
				//直接跳入	
				window.location.href=hrefUrl;			
			}
			else if(state==1){ 
				var backUrl="list.html?bookId="+bookId+"&typeId="+groupId;
			    saveBackUrl(backUrl);//保存当前地址                                              
				window.location.href="login.html"; 								
			}
			else if(state==2){
				unlocked(obj);//解锁弹窗				
				//autoCloseMsg("没有使用权限，请付费后再使用",2000);
				//return false;
			}
		}
   ); 
}

var lockedWin;
//解锁弹窗
function unlocked(obj){	
	var curId=$(obj).attr("id");
	var titText="此单元还没有解锁，是否解锁？";
	var str="";
	str+='<div class="topbg"></div>';
	str+='<div class="msgTipsTit">';
	str+='<p>'+titText+'</p>';			
	str+='<div id="uploadTools"><a href="javascript:unlockedClass('+bookId+')" id="btnStart">好哒</a><a href="javascript:void(0)" id="btnCancle" onclick="lockedClose()">算了</a></div>';
	str+='</div>';	
	lockedWin = dialog({		
		width:235,	
		height:140,	
		skin: 'msgTips',
		content: str
	});
	lockedWin.showModal();
}
//解锁单元课程
function unlockedClass(curBookId){	
    lockedClose();
	//进入购买套餐页，如果支付成功后，又要跳会目录页。
	var backUrl='list.html?bookId='+bookId+'&typeId='+typeId;//解锁成功后要跳回这个页面。
	saveBackUrl(backUrl);//保存当前地址
	var data = {"name":"information","value":{"state":1,"backUrl": backUrl}};   
    window.WebViewJavascriptBridge.callHandler(
		'saveStudyData'
		, data
		, function() {			
		}
    );
	window.location.href="member.html?id="+curBookId;	
}
//关闭窗体
function lockedClose(){
	lockedWin.close();	
}
	
//检测系统
function checkPlatform(){
  //console.log("checkPlatform");
  var system =
  {   
        win : false,   
        mac : false,   
        xll : false   
    };   
    //检测平台    
    var p = navigator.platform;    
    
    system.win = p.indexOf("Win") == 0;   
    system.mac = p.indexOf("Mac") == 0;   
    system.x11 = (p == "X11") || (p.indexOf("Linux") == 0); 
    //跳转语句    
    if(system.win||system.mac||system.xll)
    { 
      console.log("PC端");
        return 0;
  }
  else
  {
    if(navigator.userAgent.indexOf("Mac")<0)
    {
      console.log("安卓端");
      return 1;
    }
    else
    {
      console.log("苹果端");
      return 2;
    }
    
  }
}

//添加 callback
function setupWebViewJavascriptBridge(callback) {
	  if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge); }
		  
	  if(checkPlatform() == 1){
		  document.addEventListener('WebViewJavascriptBridgeReady', function() {
			  callback(WebViewJavascriptBridge)
		  }, false)
		  return;
	  }
		  
	  if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback); }
	  window.WVJBCallbacks = [callback];
	  var WVJBIframe = document.createElement('iframe');
	  WVJBIframe.style.display = 'none';
	  WVJBIframe.src = 'wvjbscheme://__BRIDGE_LOADED__';
	  document.documentElement.appendChild(WVJBIframe);
	  setTimeout(function() { document.documentElement.removeChild(WVJBIframe) }, 0)
}
setupWebViewJavascriptBridge(function(bridge) {

	if(checkPlatform() == 1){
		bridge.init(function(message, responseCallback) {                                            
		  log('JS got a message', message)
		  var data = { 'Javascript Responds':'Wee!' }
		  log('JS responding with', data)
		  responseCallback(data)
		})
	}
})

//定时关闭的对话杠，参数为内容和定时时间
function autoCloseMsg(title,time){
	var d = dialog({
		padding:10,
		skin:'timeWin',					
		content: title
	});
	d.showModal();
	setTimeout(function () {
		d.close().remove();
	}, time);	
}

/*--获取网页传递的参数：
    如获取Default.aspx?ID=123这个URL中ID的值时，调用方法：request("ID")
--*/
function request(paras)
{
    var url = location.href;
    var paraString = url.substring(url.indexOf("?")+1,url.length).split("&");
    var paraObj = {}
    for (i=0; j=paraString[i]; i++){
    paraObj[j.substring(0,j.indexOf("=")).toLowerCase()] = j.substring(j.indexOf("=")+1,j.length);
    }
    var returnValue = paraObj[paras.toLowerCase()];
    if(typeof(returnValue)=="undefined"){
    return "";
    }else{
    return returnValue;
    }
}

/**
 * 获取浏览器窗口的可视区域的宽度
 */
function getViewPortSize() {
	var o = {
		"w": NaN,
		"h": NaN
	};
	o.w = document.documentElement.clientWidth || document.body.clientWidth;
	o.h = document.documentElement.clientHeight || document.body.clientHeight;
	return o;
}