// JavaScript Document
var mySwiper;
var curIndex=0;//当前页码
var initPage=1;//初始化书本ID
$(function(){	
  initGetOldBookId(function(){     
		
	   loadSwiper();
	   $('.arrL').on('click', function(e){
			e.preventDefault();
			mySwiper.swipePrev();
		});
	   $('.arrR').on('click', function(e){
			e.preventDefault();
			mySwiper.swipeNext();
		});
   });
})
//动态加载滚动插件
function loadSwiper(){
//	if(request("bookId")==""){
//		initPage=0;
//	}
//	else{
//		initPage = parseInt(request("bookId"));
//	}	
	//获取数据后隐藏默认图片
	$(".swiper-wrapper").html("");
	for(var i=0;i<2;i++){
		var parentObj=document.createElement("div");
			parentObj.className="swiper-slide";	
			parentObj.id="s_"+(i+1);				
		$(parentObj).append('<img src="images/img'+(i+1)+'.jpg" alt=""/>');				
		$('.swiper-wrapper').append($(parentObj));
	}	
	mySwiper = new Swiper('.swiper-container',{
		//pagination: '.swiper-pagination',
		initialSlide:initPage-1,
		loop:true,
		grabCursor: true,
		//paginationClickable: true
		observer: true,//修改swiper自己或子元素时，自动初始化swiper
		observeParents: true,//修改swiper的父元素时，自动初始化swiper
		//onSlidePrev: function(swiper){			
			//alert("向右拖:"+idStr);
		//},
		//onSlideNext: function(swiper){		    
			//alert("向左拖:"+idStr);
		//},
		onSlideChangeEnd: function(swiper){
			//slider切换结束时执行事件
			//alert("你滑动了"+getCurBookId());
			var oldBookId=getCurBookId();
			saveBookId(oldBookId);
		}
	});	
}

//获取当前选中的书本ID
function getCurBookId(){
	var idStr=0;			
	$(".swiper-slide").each(function(index) {
		var curObj=$(this);				
		if(curObj.hasClass("swiper-slide-visible")){					
			var id=curObj.attr("id");					
			idStr=id.split('_')[1];	
		}			
	});	
	return idStr;
}

//保存选中的BOOKID，将它存入后台
function saveBookId(bId){
	var data = {"name":"historyBookId","value":{"state":1,"hisBookId": bId}};   
    window.WebViewJavascriptBridge.callHandler(
		'saveStudyData'
		, data
		, function() {}
    );
}

//初始化获取上次操作的书本ID
function initGetOldBookId(callback){
   var data = "historyBookId";//saveBookId函数中的Key名称
   if(window.WebViewJavascriptBridge){
	   window.WebViewJavascriptBridge.callHandler(
			'getStudyData'
			, data
			, function(responseData) {
				if(responseData.state==1){
					initPage=responseData.hisBookId;//获取上次的书本ID					
				}
                callback();
			}
	   );
   }
   else{
		setTimeout(function () { 
        	initGetOldBookId(callback);
		}, 500);//延迟5秒再执行
   }
}
/*--获取网页传递的参数：
    如获取Default.aspx?ID=123这个URL中ID的值时，调用方法：request("ID")
--*/
function request(paras)
{
    var url = location.href;
    var paraString = url.substring(url.indexOf("?")+1,url.length).split("&");
    var paraObj = {}
    for (i=0; j=paraString[i]; i++){
    paraObj[j.substring(0,j.indexOf("=")).toLowerCase()] = j.substring(j.indexOf("=")+1,j.length);
    }
    var returnValue = paraObj[paras.toLowerCase()];
    if(typeof(returnValue)=="undefined"){
    return "";
    }else{
    return returnValue;
    }
}

//检测系统
function checkPlatform(){
    console.log("checkPlatform");
    var system =
    {
        win : false,
        mac : false,
        xll : false
    };
    //检测平台
    var p = navigator.platform;
    
    system.win = p.indexOf("Win") == 0;
    system.mac = p.indexOf("Mac") == 0;
    system.x11 = (p == "X11") || (p.indexOf("Linux") == 0);
    //跳转语句
    if(system.win||system.mac||system.xll)
    {
        console.log("PC端");
        return 0;
    }
    else
    {
        if(navigator.userAgent.indexOf("Mac")<0)
        {
            console.log("安卓端");
            return 1;
        }
        else
        {
            console.log("苹果端");
            return 2;
        }
        
    }
}

//添加 callback
function setupWebViewJavascriptBridge(callback) {
    if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge); }		  
    if(checkPlatform() == 1){
        document.addEventListener('WebViewJavascriptBridgeReady', function() {
		  callback(WebViewJavascriptBridge);
		}, false);
        return;
    }		  
    if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback); }
    window.WVJBCallbacks = [callback];
    var WVJBIframe = document.createElement('iframe');
    WVJBIframe.style.display = 'none';
    WVJBIframe.src = 'wvjbscheme://__BRIDGE_LOADED__';
    document.documentElement.appendChild(WVJBIframe);
    setTimeout(function() { document.documentElement.removeChild(WVJBIframe) }, 0)
}
setupWebViewJavascriptBridge(function(bridge) {                             
	if(checkPlatform() == 1){
		bridge.init(function(message, responseCallback) {
			log('JS got a message', message);
			var data = {'Javascript Responds':'Wee!'};
			log('JS responding with', data);
			responseCallback(data);
		});
	}
});