// JavaScript Document
var c=61; //倒计时
var t; //定计器
var linkURL = "javascript:history.back(-1)";

$(function(){
	$("#regTxtPhone").bind('keydown', function (e) {
		$(".codeDisable").hide();		
		if($(".waitGet").css("display")=="block"){			
			$(".codeActive").hide();
		}	
		else{
			$(".codeActive").show();
		}	
	});	
	bindValidPassEvent("txtPass");
	bindValidPassEvent("regTxtPass");	
});

//保存要跳转回来的URL地址，将地址存入后台
function saveBackUrl(backUrl){
	var data = {"name":"backUrl","value":{"state":1,"linkURL": backUrl}};   
    window.WebViewJavascriptBridge.callHandler(
		'saveStudyData'
		, data
		, function() {}
    );
}

//初始化获取返回链接地址并修改返回按钮的地址
function initGetBackUrl(){ 
   var data = "backUrl";//saveBackUrl函数中的Key名称
   if(window.WebViewJavascriptBridge){
	   window.WebViewJavascriptBridge.callHandler(
			'getStudyData'
			, data
			, function(responseData) {
				if(responseData.state==1){
					var backURL=responseData.linkURL;//获取的返回地址
					if(backURL!=""){
						$(".fix_h_L>a").attr("href",backURL);//修改返回按钮的链接地址
                        linkURL = backURL;
					}
					else{
						//如果为空，则默认采用history.back(-1)
						$(".fix_h_L>a").attr("href","javascript:history.back(-1)");
					}
				}
			}
	   );
   }
   else{
		setTimeout(function () { 
        	initGetBackUrl();
		}, 500);//延迟5秒再执行
	}
}

//只能输入正整数
function fillNumOnly(obj) {  
    var str = obj.value;  
    if (str.trim() == "")  
        return;		 
    if (/^1[34578]\d{9}$/g.test(str)) {  
        obj.value = str.substr(0, str.length - 1);  
    }  
}

//获取登录用户帐号
function getUserName(callback){
	//调用后台修改密码
	var data = {};
	var userName="";
	if(window.WebViewJavascriptBridge){
		window.WebViewJavascriptBridge.callHandler(
			'getUserInfo'
			, data
			, function(responseData) {
				var isSucced=responseData.scuss;
				if(isSucced){                                                   
                    callback(responseData.userInfo.userPhone)
				}
				else{
                    callback("");
					//autoCloseMsg("获取用户信息失败，失败原因："+responseData.errorMsg,2000);
				}
			}
		);	
	}
	else{
		setTimeout(function () { 
        	getUserName(callback);
		}, 500);//延迟5秒再执行
	}
}

//定时关闭的对话杠，参数为内容和定时时间
function autoCloseMsg(title,time){
	var d = dialog({
		padding:10,
		skin:'timeWin',					
		content: title
	});
	d.showModal();
	setTimeout(function () {
		d.close().remove();
	}, time);	
}

/*获取验证码*/
function getCode(){
	if(validTextPhone()){	
	    $(".codeDisable").hide();
		$(".codeActive").hide();
		$(".waitGet").show();
		timedCount();
		
		var userPhone=$("#regTxtPhone").val();
		//调用后台获取验证码函数
		var data = {"telePhone":userPhone};
		window.WebViewJavascriptBridge.callHandler(
			'gainMessageCode'
			, data
			, function(responseData) {
				var isSucced=responseData.scuss;
				if(isSucced){
					autoCloseMsg('获取验证码成功！验证码会以短信方式发送到用户手机中',2000);					
				}
				else{
					c=1;//获取验证码失败，将计时器清零。
					autoCloseMsg("获取验证码失败，失败原因："+responseData.errorMsg,2000);
				}
			}
		);
	}
}

/*再次获取验证码*/
function againGet(){
	if(validTextPhone()){
		$(".codeDisable").hide();
		$(".againGet").hide();
		$(".codeActive").hide();
		$(".waitGet").show();
		c=61;//重置秒数，可能前面已经将它置为0了，所以要重启一次
		timedCount();
			
		var userPhone=$("#regTxtPhone").val();
		//调用后台获取验证码函数
		var data = {"telePhone":userPhone};
		window.WebViewJavascriptBridge.callHandler(
			'gainMessageCode'
			, data
			, function(responseData) {
				var isSucced=responseData.scuss;
				if(isSucced){
					autoCloseMsg('获取验证码成功！验证码会以短信方式发送到用户手机中',2000);					
				}
				else{
					c=1;//获取验证码失败，将计时器清零。					
					autoCloseMsg("获取验证码失败，失败原因："+responseData.errorMsg,2000);
				}
			}
		);
	}
}

function validTextPhone(){	
	var isSucce=false;
	var v=$("#regTxtPhone").val();
	if(v!=""){
		var isPhone=validMobieCode(v);	
		if(isPhone){
			isSucce=true;
		}
		else{						
			autoCloseMsg('手机号码格式不正确！',2000);
		}
	}
	else{	
		autoCloseMsg('手机号码不能为空！',2000);		
	}
	return isSucce;
}

function bindValidPassEvent(objId){
	$("#"+objId).blur(function(){	  
	  var passStr=$(this).val();
	  if(getStrength(passStr)){
		  //autoCloseMsg('验证匹配成功！',2000);	
	  }
	  else{
		  autoCloseMsg('密码由6-20位字母或数字组成。',2000);	
	  }
	});
}

//验证密码
function getStrength(passwd){  
    var isSucced = false; 
	// [验证] 大写字母，小写字母或数字，并且是6-20位  
    if (passwd.match(/^[0-9A-Za-z]{6,20}$/))  
    {  
       isSucced=true;
    }  
    return isSucced;  
}  


/***************************************************
秒数按钮
***************************************************/
function timedCount()  
{  
    c=c-1 
	$(".waitGet").get(0).value = c + " S"  
	if(c>0){//最多60秒
		/*输入验证码时停止计时功能
		var codStr=$("#txtCode").val();
		if(codStr!="" && codStr!="undefined"){
			//clearAll();				
		}
		else{
			t=setTimeout("timedCount()",1000);
		}*/
		t=setTimeout("timedCount()",1000);
	}
	else{
		$(".codeDisable").hide();
		$(".codeActive").hide();
		$(".waitGet").hide();
		$(".againGet").show();
		//clearAll();			
	}
}
function clearAll(){  
	c=0; 
	clearTimeout(t);  
}  
//匹配13，14，15，18开头的手机号码
function validMobieCode(phone){
	//var tel = phone;
	var reg = /^0?1[3|4|5|7|8][0-9]\d{8}$/;
	if (reg.test(phone)) {
	  return true;
	}else{
	  return false;
	};	
}
//匹配6位验证码
function code_check(code)
{
	if (code =="" || !code.match(/\d{6}/) )
	{
		return false;
	}
	else{
		return true;
	}
}
var curCode="";//当前验证码
/*下一步按钮*/
function goNext(){
	var v=$("#regTxtPhone").val();
	if(v!=""){
		var isPhone=validMobieCode(v);	
		if(isPhone){
			var codStr=$("#txtCode").val();
			if(codStr!=""){
				if(code_check(codStr)){
					
					//调用后台去验证验证和用户匹配情况
					var data = {"telePhone":v,"validCode":codStr};
					window.WebViewJavascriptBridge.callHandler(
						'checkCode'
						, data
						, function(responseData) {
							var isSucced=responseData.scuss;
							if(isSucced){
								curCode=codStr;
								$("#textBox1").hide();
								$("#textBox2").show();
								$("#nextBtn").hide();					
								$("#okBtn").show();	
								$(".fix_h_M").html("填写密码");
										
								//autoCloseMsg('验证匹配成功！',2000);	
							}
							else{
								autoCloseMsg("验证匹配失败，失败原因："+responseData.errorMsg,2000);
							}
						}
					);		
					
							
				}
				else{
					autoCloseMsg('验证码有误',2000);
				}			
			}
			else{
				t=setTimeout("timedCount()",1000);
			}
		}
		else{
			autoCloseMsg('请输入正确的手机号',2000);
		}
	}
	else{	
		autoCloseMsg('请输入手机号码',2000);		
	}
}

/*通过验证码来修改重置用户密码*/
function btnOk(){
	var userPhone=$("#regTxtPhone").val();
	var passStr=$("#regTxtPass").val();
	var codStr=$("#txtCode").val();
	if(passStr!=""){
		//调用后台重置密码
		var data = {"telePhone":userPhone,"messageCode":codStr,"PassWord":passStr};
		window.WebViewJavascriptBridge.callHandler(
			'resetPassWord'
			, data
			, function(responseData) {
				var isSucced=responseData.scuss;
				if(isSucced){
					curCode=codStr;
					$("#textBox1").hide();
					$("#textBox2").show();
					$("#nextBtn").hide();					
					$("#okBtn").show();								
					//autoCloseMsg('密码重置成功！',2000);	
					saveBackUrl("index.html");//修改登录页的返回按钮地址					
					window.location.href="login.html";					
				}
				else{
					autoCloseMsg("密码重置失败，失败原因："+responseData.errorMsg,2000);
				}
			}
		);		
	}
	else{
		autoCloseMsg('请输入新密码',2000);	
	}
}

/*注册下一步按钮*/
function regNext(){
	var v=$("#regTxtPhone").val();
	if(v!=""){
		var isPhone=validMobieCode(v);
		checkIsRegister(v,function(scuss,state){
			if(isPhone){
				var codStr=$("#txtCode").val();
				if(codStr!=""){
					if(code_check(codStr)){
						if(scuss){
							if(state=="2"){//未注册
								//调用后台去验证验证和用户匹配情况
								var data = {"telePhone":v,"validCode":codStr};
								window.WebViewJavascriptBridge.callHandler(
									'checkCode'
									, data
									, function(responseData) {
										var isSucced=responseData.scuss;
										if(isSucced){										
											curCode=codStr;
											$("#textBox1").hide();
											$("#textBox2").show();
											$("#nextBtn").hide();					
											$("#okBtn").show();	
											$(".fix_h_M").html("填写密码");
													
											//autoCloseMsg('验证匹配成功！',2000);	
										}
										else{
											autoCloseMsg("验证匹配失败，失败原因："+responseData.errorMsg,2000);
										}
									}
								);		
							}
							else{//已注册
								autoCloseMsg('此手机号码已经注册过，请勿重复注册！',2000);	
							}
						}
						else{
							autoCloseMsg('检查注册过程失败！',2000);
						}		
					}
					else{
						autoCloseMsg('验证码有误',2000);
					}			
				}
				else{
					t=setTimeout("timedCount()",1000);
				}
			}
			else{
				autoCloseMsg('请输入正确的手机号',2000);
			}
		});	
	}
	else{	
		autoCloseMsg('请输入手机号码',2000);		
	}
}
/*检查手机号是否已注册*/
function checkIsRegister(userPhone,callback){	
	var data = {"telePhone":userPhone};
    var isSucced=false;
	var state;
	if(window.WebViewJavascriptBridge){
		window.WebViewJavascriptBridge.callHandler(
			'checkPhone'
			, data
			, function(responseData) {
				isSucced=responseData.scuss;
                state=responseData.state;
                
				callback(isSucced,state);
			}
		);
	}
	else{
		callback(isRegisted,state);
	}
}

/*注册帐号*/
function btnRegister(){
	var userPhone=$("#regTxtPhone").val();
	var passStr=$("#regTxtPass").val();
	var codStr=$("#txtCode").val();	
	if(passStr!=""){
		//调用后台重置密码
		var data = {"userName":userPhone,"messageCode":codStr,"passWord":passStr};
		window.WebViewJavascriptBridge.callHandler(
			'register'
			, data
			, function(responseData) {
				var isSucced=responseData.scuss;
				if(isSucced){
					curCode=codStr;
					$("#textBox1").hide();
					$("#textBox2").show();
					$("#nextBtn").hide();					
					$("#okBtn").show();								
					//autoCloseMsg('帐户注册成功！',2000);	
					window.location.href="login.html";
				}
				else{
					autoCloseMsg("帐户注册失败，失败原因："+responseData.errorMsg,2000);
				}
			}
		);		
	}
	else{
		autoCloseMsg('请输入新密码',2000);	
	}
}

/*登录提交*/
function loginSumbit(){
	var userPhone=$("#txtPhone").val();
	var userPass=$("#txtPass").val();
	var isSucced=loginValid();
	if(isSucced){		
		//调用后台登录函数
		var data = {"userName":userPhone,"password":userPass};
		window.WebViewJavascriptBridge.callHandler(
			'login'
			, data
			, function(responseData) {
				var isSucced=responseData.scuss;
				if(isSucced){					
                    //window.location.href = "javascript:history.back(-1)";//这种方式在IOS中不能马上刷新页面。
					//跳回地址需要事先获得
                    window.location.href = linkURL;
					autoCloseMsg("登录成功！",2000);	
				}
				else{
					autoCloseMsg("登录失败，失败原因："+responseData.errorMsg,2000);						
				}
			}
		);		
	}
}

/*登录数据验证*/
function loginValid(){
	var v=$("#txtPhone").val();
	var p=$("#txtPass").val();
	var isSucced=false;
	if(v!=""){
		var isPhone=validMobieCode(v);	
		if(isPhone){
			if(p!=""){				
				isSucced=true;
			}
			else{
				autoCloseMsg('请输入密码',2000);	
			}			
		}
		else{
			autoCloseMsg('请输入正确的手机号',2000);
		}
	}
	else{	
		autoCloseMsg('请输入手机号码',2000);		
	}
	return isSucced;
}

/*退出登录*/
var dialogExit;
function exitLogin(){
	var titText="您真的需要退出吗？";
	var str="";
	str+='<div class="topbg"></div>';
	str+='<div class="msgTipsTit">';
	str+='<p>'+titText+'</p>';			
	str+='<div id="uploadTools"><a href="javascript:exitEvent()" id="btnStart">是</a><a href="javascript:void(0)" id="btnCancle" onclick="exitClose()">否</a></div>';
	str+='</div>';	
	dialogExit = dialog({
		width:235,	
		height:100,			
		content: str,
		skin: 'msgTips'
	});
	dialogExit.showModal();	
} 

//解锁单元课程
function exitEvent(){
	exitClose();		
   //调用后台退出登录函数
	var data = {};
	window.WebViewJavascriptBridge.callHandler(
		'loginOut'
		, data
		, function(responseData) {
			var isSucced=responseData.scuss;
			if(isSucced){
				$(".login").show();
				$(".logined").hide();	
				$(".botpanle").hide();
				$("#feedback").parent().hide();
				$("#preMsg").attr("href","login.html");
				$("#member").attr("href","login.html");
			}
			else{
				autoCloseMsg("用户退出登录失败！",2000);						
			}
		}
	);		 
}
//关闭窗体
function exitClose(){
	dialogExit.close();
}

//检测系统
function checkPlatform(){
  console.log("checkPlatform");
  var system =
  {   
        win : false,   
        mac : false,   
        xll : false   
    };   
    //检测平台    
    var p = navigator.platform;    
    
    system.win = p.indexOf("Win") == 0;   
    system.mac = p.indexOf("Mac") == 0;   
    system.x11 = (p == "X11") || (p.indexOf("Linux") == 0); 
    //跳转语句    
    if(system.win||system.mac||system.xll)
    { 
      console.log("PC端");
        return 0;
  }
  else
  {
    if(navigator.userAgent.indexOf("Mac")<0)
    {
      console.log("安卓端");
      return 1;
    }
    else
    {
      console.log("苹果端");
      return 2;
    }
    
  }
}

//添加 callback
function setupWebViewJavascriptBridge(callback) {
	  if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge); }
		  
	  if(checkPlatform() == 1){
		  document.addEventListener('WebViewJavascriptBridgeReady', function() {
			  callback(WebViewJavascriptBridge)
		  }, false)
		  return;
	  }
		  
	  if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback); }
	  window.WVJBCallbacks = [callback];
	  var WVJBIframe = document.createElement('iframe');
	  WVJBIframe.style.display = 'none';
	  WVJBIframe.src = 'wvjbscheme://__BRIDGE_LOADED__';
	  document.documentElement.appendChild(WVJBIframe);
	  setTimeout(function() { document.documentElement.removeChild(WVJBIframe) }, 0)
}
setupWebViewJavascriptBridge(function(bridge) {

	if(checkPlatform() == 1){
		bridge.init(function(message, responseCallback) {                                            
		  log('JS got a message', message)
		  var data = { 'Javascript Responds':'Wee!' }
		  log('JS responding with', data)
		  responseCallback(data)
		})
	}
})