// JavaScript Document
isIosLogin=false;
//获取支付单价列表
function getPriceList(bookId){
	//调用后台获取支付单价列表
	var data = {"gradeID":bookId};
	if(window.WebViewJavascriptBridge){
		window.WebViewJavascriptBridge.callHandler(
			'getProductList'
			, data
			, function(responseData) {
				var isSucced=responseData.scuss;
				if(isSucced){                                                   
                    //callback(responseData.userInfo.userPhone);	
					var payListStr="";				
					for(var i=0;i<responseData.productList.length;i++){
                                                   
                        var product = responseData.productList[i]
						var url='pay.html?bookid='+bookId+'&id='+product.productID;
						var temp='<a href="javascript:void(0)" class="btnKai" title="'+product.state+'" hidUrl="'+url+'">'+product.state+'</a>';
						payListStr+='<li><span>'+product.title+'</span>'+temp+'</li>';
					}
					$("#payList").html(payListStr);				
					if(responseData.vip){
						$("#payState").html("已开通");
					}
					else{
						$("#payState").html("未开通");
					}
					$("#payList>li>a").each(function(){						
						var $obj=$(this);
						$obj.bind("click",function(){
							var curUrl=$obj.attr("hidUrl");
							showIosPannel(curUrl);
						})
					});
				}
				else{                    
					autoCloseMsg("获取用户信息失败，失败原因："+responseData.errorMsg,2000);
				}
			}
		);	
	}
	else{
		setTimeout(function () { 
        	getPriceList(bookId);
		}, 500);//延迟5秒再执行
	}
}

//获取登录用户帐号
function getUserName(callback){
	//调用后台修改密码
	var data = {};
	var userName="";
	if(window.WebViewJavascriptBridge){
		window.WebViewJavascriptBridge.callHandler(
			'getUserInfo'
			, data
			, function(responseData) {
				var isSucced=responseData.scuss;
				if(isSucced){                                                   
                    callback(responseData.userInfo.userPhone);
					isIosLogin=true;
				}
				else{
                    callback("");
					isIosLogin=false;
					//autoCloseMsg("获取用户信息失败，失败原因："+responseData.errorMsg,2000);
				}
			}
		);	
	}
	else{
		setTimeout(function () { 
        	getUserName(callback);
		}, 500);//延迟5秒再执行
	}
}
//保存要跳转回来的URL地址，将地址存入后台
function saveBackUrl(backUrl){
	var data = {"name":"backUrl","value":{"state":1,"linkURL": backUrl}};   
    window.WebViewJavascriptBridge.callHandler(
		'saveStudyData'
		, data
		, function() {}
    );
}

//初始化获取返回链接地址并修改返回按钮的地址
function initGetBackUrl(){ 
   var data = "backUrl";//saveBackUrl函数中的Key名称
   if(window.WebViewJavascriptBridge){
	   window.WebViewJavascriptBridge.callHandler(
			'getStudyData'
			, data
			, function(responseData) {
				if(responseData.state==1){
					var backURL=responseData.linkURL;//获取的返回地址
					if(backURL!=""){
						$(".fix_h_L>a").attr("href",backURL);//修改返回按钮的链接地址
                        linkURL = backURL;
					}
					else{
						//如果为空，则默认采用history.back(-1)
						$(".fix_h_L>a").attr("href","javascript:history.back(-1)");
					}
				}
			}
	   );
   }
   else{
		setTimeout(function () { 
        	initGetBackUrl();
		}, 100);//延迟5秒再执行
	}
}

//IOS开通时需要选择。
function showIosPannel(payUrl){	
	if(checkPlatform() == 1){//安卓直接跳转
		window.location.href=payUrl;
	}	
	else if(checkPlatform() == 2){
		if(!isIosLogin){//未登录
			var str='<div class="botpanle"><a href="javascript:void(0)" title="登录购买" class="btnLogon" onclick="goLogin()">登录购买</a>';
			str+='<a href="'+payUrl+'" title="游客购买" class="btnLogon">游客购买</a>';
			str+='<a href="javascript:void(0)" title="取消" class="btnLogon" onClick="exitIosPannel();">取消</a></div>';
			$(".wrap").append(str);	
			$(".botpanle").show();//显示页脚选项内容
		}
		else{
			window.location.href=payUrl;
		}
	}	
}
//登录购买--先保存回传地址
function goLogin(){	
	var backUrl="member.html?id="+request("id");
	saveBackUrl(backUrl);//保存当前地址                                              
	window.location.href="login.html"; 	
}

//取消操作
function exitIosPannel(){
	$(".botpanle").remove();
}

//获取支付方式列表
function getPayList(bookId,proId){
	//var bookId=
	//调用后台获取支付单价列表
	var data = {"productID":proId,"gradeID":bookId};
	if(window.WebViewJavascriptBridge){
		window.WebViewJavascriptBridge.callHandler(
			'getPayWayList'
			, data
			, function(responseData) {
				var isSucced=responseData.scuss;
				var titleStr=responseData.payDetails;
				if(isSucced){                                                   
					var payListStr="";				
					for(var i=0;i<responseData.payWayList.length;i++){                                                   
                        var payWay = responseData.payWayList[i];                                                   
						var imgIndex=parseInt(payWay.image);
						//image = 1 微信 2支付宝 3移动 4苹果支付
						//ico4微信 ico5支付宝 ico6移动 ico7苹果支付
						var icoClass="ico"+(imgIndex+3);//图标样式						
						payListStr+='<li title="'+payWay.title+'" hidId="'+payWay.payID+'" onClick="payMoney(this)"><b class="'+icoClass+'"></b><a href="javascript:void(0)" class="payItem">'+payWay.title+'</a></li>';
					}
					$("#widItem").html(payListStr);	
					$(".orange").html(titleStr);			
				}
				else{                    
					autoCloseMsg("获取用户信息失败，失败原因："+responseData.errorMsg,2000);
				}
			}
		);	
	}
	else{
		setTimeout(function () { 
        	getPayList(bookId,proId);
		}, 500);//延迟5秒再执行
	}
}

//支付接口
function payMoney(obj){  
   var payId=$(obj).attr("hidId")
   var data = {"productID":proId,"payID": payId,"gradeID":bookId};
   window.WebViewJavascriptBridge.callHandler(
		'buyProduct'
		, data
		, function(responseData) {
			var isSucced=responseData.scuss;
			if(isSucced){                                                   
				window.location.href="paySucced.html"; 				
			}
			else{                    
				autoCloseMsg(responseData.errorMsg,2000);
			}
		}
   ); 
}

//初始化获取返回链接地址
function initGetListUrl(){ 
   var data = "information";
   if(window.WebViewJavascriptBridge){
	   window.WebViewJavascriptBridge.callHandler(
			'getStudyData'
			, data
			, function(responseData) {
				if(responseData.state==1){
					$(".fix_h_L>a").attr("href",responseData.backUrl);
				}
			}
	   );
   }
   else{
		setTimeout(function () { 
        	initGetListUrl();
		}, 500);//延迟5秒再执行
	}
}

//检测系统
function checkPlatform(){
  console.log("checkPlatform");
  var system =
  {   
        win : false,   
        mac : false,   
        xll : false   
    };   
    //检测平台    
    var p = navigator.platform;    
    
    system.win = p.indexOf("Win") == 0;   
    system.mac = p.indexOf("Mac") == 0;   
    system.x11 = (p == "X11") || (p.indexOf("Linux") == 0); 
    //跳转语句    
    if(system.win||system.mac||system.xll)
    { 
      console.log("PC端");
        return 0;
  }
  else
  {
    if(navigator.userAgent.indexOf("Mac")<0)
    {
      console.log("安卓端");
      return 1;
    }
    else
    {
      console.log("苹果端");
      return 2;
    }
    
  }
}

//添加 callback
function setupWebViewJavascriptBridge(callback) {
	  if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge); }
		  
	  if(checkPlatform() == 1){
		  document.addEventListener('WebViewJavascriptBridgeReady', function() {
			  callback(WebViewJavascriptBridge)
		  }, false)
		  return;
	  }
		  
	  if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback); }
	  window.WVJBCallbacks = [callback];
	  var WVJBIframe = document.createElement('iframe');
	  WVJBIframe.style.display = 'none';
	  WVJBIframe.src = 'wvjbscheme://__BRIDGE_LOADED__';
	  document.documentElement.appendChild(WVJBIframe);
	  setTimeout(function() { document.documentElement.removeChild(WVJBIframe) }, 0)
}
setupWebViewJavascriptBridge(function(bridge) {

	if(checkPlatform() == 1){
		bridge.init(function(message, responseCallback) {                                            
		  log('JS got a message', message)
		  var data = { 'Javascript Responds':'Wee!' }
		  log('JS responding with', data)
		  responseCallback(data)
		})
	}
})

/*--获取网页传递的参数：
    如获取Default.aspx?ID=123这个URL中ID的值时，调用方法：request("ID")
--*/
function request(paras)
{
    var url = location.href;
    var paraString = url.substring(url.indexOf("?")+1,url.length).split("&");
    var paraObj = {}
    for (i=0; j=paraString[i]; i++){
    paraObj[j.substring(0,j.indexOf("=")).toLowerCase()] = j.substring(j.indexOf("=")+1,j.length);
    }
    var returnValue = paraObj[paras.toLowerCase()];
    if(typeof(returnValue)=="undefined"){
    return "";
    }else{
    return returnValue;
    }
}

//定时关闭的对话杠，参数为内容和定时时间
function autoCloseMsg(title,time){
	var d = dialog({
		padding:10,
		skin:'timeWin',					
		content: title
	});
	d.showModal();
	setTimeout(function () {
		d.close().remove();
	}, time);	
}